<?php
/*
Plugin Name: Simple ajax contact form by webislife.ru
Plugin URI: http://webislife.ru
Description: Простая ajax форма обратной связи / simple ajax form 
Tags: ajax, contact form, ajax form
Author: Denis Strokov
Author URI: http://webislife.ru
Version: 1.0
*/
add_action('init', 'wl_script_enqueuer' );
add_action('init', 'wl_add_shortcode');
add_action('wp_ajax_wl_send_ajax', 'wl_send_ajax');
add_action('wp_ajax_nopriv_wl_send_ajax', 'wl_send_ajax');

function wl_add_shortcode(){
    add_shortcode('wlgetform', 'wl_form');
}
function wl_form($atts){
    //Получаем из шорткода e-mail
    $mailto = $atts['email'];
    
    if(empty($mailto)){
        exit('Нет e-mail');
    }
    $nonce = wp_create_nonce('wl_send_ajax_nonce');
    $link = admin_url('admin-ajax.php?action=wl_send_ajax&nonce='.$nonce);
    
    $html = "
    <div id='wl_ajax_form_plugin_container'>
    <form id='wl_ajax_form_plugin'>
    <input type='text' name='user_name' id='wl_user_name' placeholder='Представьтесь'/>
    <input type='text' name='user_contact' id='wl_user_contact' placeholder='Контакт для связи'/>
    <input type='text' name='user_question' id='wl_user_question' placeholder='Текст вопроса'/>
    <input type='hidden' name='wl_mailto' value='$mailto' id='wl_mailto_form'/>
    <input type='hidden' name='wl_ajax_form_nonce' value='$nonce' id='wl_ajax_form_nonce'/>
    <div id='wl_send_form_btn'>Отправить</div>
    </form>
    <div id='wl_form_infomsg'></div>
    </div>
    ";
    return $html;
}
function wl_send_ajax(){
    $result = array();
    
    if ( !wp_verify_nonce( $_REQUEST['nonce'], "wl_send_ajax_nonce")) {
      exit("Fail nonce");
   }
   
    $to = $_REQUEST['mailto'];
    $name = htmlspecialchars($_REQUEST['name']);
    $contact = htmlspecialchars($_REQUEST['contact']);
    $question = htmlspecialchars($_REQUEST['quest']);

    if(empty($name)||empty($contact)||empty($question)) {
        $result['type'] = "false";
        $result = json_encode($result);
        echo $result;
        die();
    }
    $subject = 'Сообщение с сайта'.wp_title();
    
    $headers = "From:($name)\r\n";
    $headers .= "MIME-Version: 1.0\r\n";
    $headers .= "Content-Type: text/html; charset=utf-8\r\n";
    
    $message = "<html><div>";
    $message .= 'Сообщение с сайта <br /> От: '. $name;
    $message .= '<br /> Контакт для связи: '. $contact;
    $message .='<br /> Текст: '. $question .'<br />';
    $message .= '<small>Сообщение отправлено автоматически и не требует ответа</small>';
    $message .= "</div></html>\r\n";
    mail($to, $subject, $message, $headers);
  
    $result['type'] = "success";
    $result = json_encode($result);
    echo $result;
    die();
}

function wl_script_enqueuer() {
   wp_register_script( "wl_send_ajax", WP_PLUGIN_URL.'/webislife-contactform/js/wlajaxform.js', array('jquery') );
   wp_localize_script( 'wl_send_ajax', 'wlAjax', array( 'ajaxurl' => admin_url( 'admin-ajax.php' )));        
   wp_enqueue_script( 'jquery' );
   wp_enqueue_script( 'wl_send_ajax' );
}